#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
typedef long long ll, i64;
const int N = 2e5 + 50;
int a[N];
int main()
{
    int T, n, m;
    scanf("%d", &T);
    while (T--)
    {
        priority_queue<int> H;
        stack<int> S;
        scanf("%d%d", &n, &m);
        for (int i = 0; i < n; i++) scanf("%d", a + i);
        ll sum = 0;
        for (int i = 0; i < n; i++)
        {
            sum += a[i];
            ll tmps = 0;
            while (!S.empty() && tmps <= a[i - 1])
            {
                sum += S.top();
                tmps += S.top();
                H.push(S.top());
                S.pop();
            }
            while (sum > m)
            {
                sum -= H.top();
                S.push(H.top());
                H.pop();
            }
            printf("%d ", i - H.size());
            H.push(a[i]);
        }
        putchar('\n');
    }
    return 0;
}